package MenuBis;
//==================================================
//BisActionInstaller.java
//==================================================
import javax.swing.*;


// classe utilitaire permettant d'installer une
// option bis dans chacun des menu d'une barre de menu.
//
public class BisActionInstaller {

    public static void install(JMenuBar pMenuBar) {
      int              lMenuCount = pMenuBar.getMenuCount();
      JMenu            lMenu;
      BisAction        lBisAction;
      BisActionUpdater lBisActionUpdater;

      for (int i=0;i<lMenuCount;i++) {
        lMenu             = pMenuBar.getMenu(i);
        lBisAction        = new BisAction();
        lBisActionUpdater = new BisActionUpdater(lBisAction);
        installBisActionUpdater(lMenu,lBisActionUpdater);

        lMenu.addSeparator();
        lMenu.add(lBisAction);
      }
    }

    private static void installBisActionUpdater(JMenu pMenu,
BisActionUpdater pUpdater) {
      int       lItemCount = pMenu.getItemCount();
      JMenuItem lItem;

      for (int i=0;i<lItemCount;i++) {

        lItem = pMenu.getItem(i);
        if (lItem instanceof JMenu) {
          installBisActionUpdater(pMenu,pUpdater);
        } 
	if(lItem instanceof JMenuItem)
	{
          lItem.addActionListener(pUpdater);
        }
      }
    }
}