package MenuBis;
import java.awt.Toolkit;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;
import javax.swing.Action;
import javax.swing.AbstractAction;
import javax.swing.JMenuItem;

// Action devant tre rattach  l'option d'un menu
// permettant de rpeter la dernire action slectionne
//
public class BisAction extends AbstractAction {

  private JMenuItem item = null;

  public BisAction() {
    super("bis ...");
    setEnabled(false);
  }

  public void actionPerformed(ActionEvent pEvent) {
    Toolkit    lTk    = Toolkit.getDefaultToolkit();
    EventQueue lQueue = lTk.getSystemEventQueue();

       // Les ActionEvent ne transitent pas par la file
       // d'vnement. On est donc oblig de produire
       // un MOUSE_RELEASED pour engendrer la
       // production d'un ActionEvent  destination de
       // this.item
    MouseEvent lEvent = new
MouseEvent(item,MouseEvent.MOUSE_RELEASED,0,0,0,0,1,false);

    lQueue.postEvent(lEvent);
  }

  public void setMenuItem(JMenuItem pItem) {
    item = pItem;

    if (!isEnabled()) {
      setEnabled(true);
    }

    putValue(Action.NAME,"bis "+item.getText());

  }
}